/* Copyright (C) 2014 by Bundesamt für Sicherheit in der Informationstechnik
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU GPL (v>=2)
 * and comes with ABSOLUTELY NO WARRANTY!
 * See LICENSE.txt for details.
 */
#ifndef ADMINSTRATORWINDOW_H
#define ADMINSTRATORWINDOW_H

/**
 * @file administratorwindow.h
 * @brief Administrator UI controller
 */

#include <QMainWindow>
#include <QSettings>
#include <QMenuBar>
#include <QTableView>
#include <QPushButton>

#include "certificatelist.h"
#include "certificatetablemodel.h"

class QMenu;
class QAction;

class AdministratorWindow : public QMainWindow
{
    Q_OBJECT

public:
    AdministratorWindow();

private slots:
    void createInstaller();
    void showSettings();
    void showHelp();
    void showAbout();
    void loadCertificateFile();
    void saveCertificateFile();
    void addCertificates();
    void removeCertificates();
    void clickedCertificate(const QModelIndex&);

private:
    void createActions();
    void createMenuBar();
    void createContent();
    void loadCertificateTable();
    void addToCertificateTable(const QList<Certificate> &certs);

    QSettings settings;

    QMenuBar *menuBar;

    QTableView *certificateView;
    CertificateList certList;
    CertificateTabelModel *certificateModel;
    QPushButton *saveButton;
    QPushButton *loadButton;
    QPushButton *addButton;
    QPushButton *removeButton;
};

#endif // ADMINSTRATORWINDOW_H
